#include <sys/ioctl.h>
#include <unistd.h>
#include "./include/I8120.h"
//#include "./include/msw.h"



int Kbhit(void){
  int n;
  ioctl(0,FIONREAD,&n);
  return n;
}

int main(void)
{
  char CANRegStatus,OverFlowStatus,OldCANRegStatus=0,OldOverFlowStatus=0;
  int Ret,SlotNo,i,j,Temp;
  unsigned short count;
  BYTE status;
  PacketStruct RxMsg;
	
  //Select the slot where the I-8120 is plugged.
  printf("Input the slot (1~7) where the I-8120 is plugged.");
  scanf("%d",&SlotNo);
  if (SlotNo<1 || SlotNo>7){
    printf("Slot number error, default to slot 1.\n");
    SlotNo=2;
  }
  else
	  SlotNo++; //0,1 are used by PAC => slot1 = 2 ,slot2 = 3 ,...
  
	Ret = I8120_Init(SlotNo);		
	if (Ret > 0) {
		printf("Init error Code=%d\n",Ret);
		return (-1);
	}
	
  printf("Baud is set to 1M\n");
  //Initiate the I-8120 module
  Ret=I8120_ConfigWithoutStruct(SlotNo,0x00000000L,0xffffffffL,8,0,0);
  if (Ret){
    printf("Config error Code=%d\n",Ret);
    return (-1);	
  }
  printf("Start to receive CAN messages.(press Enter key to exit...)\n");
	while(!Kbhit())
	{
	   Ret=I8120_RxMsgCount(SlotNo,&count);
	   for(j=0;j<count;j++)
	   {
			Ret=I8120_ReceiveWithoutStruct(SlotNo,&RxMsg.Mode,&RxMsg.Id,&RxMsg.Rtr,&RxMsg.Len,RxMsg.Data,
					  &RxMsg.UpperTimeStamp,&RxMsg.LowerTimeStamp);		  
			if (Ret)
			{
				printf("Receive Message Error, Error Code=%d.\n",Ret);
			}
			else
			{
				if (RxMsg.Rtr)
				{
					printf("%s,ID=%lx,RTR=%d,Dlen=%d\n",
					RxMsg.Mode?"2.0B":"2.0A",RxMsg.Id,RxMsg.Rtr,RxMsg.Len);
				}
				else
				{
					printf("%s,ID=%lx,RTR=%d,Dlen=%d",
					RxMsg.Mode?"2.0B":"2.0A",RxMsg.Id,RxMsg.Rtr,RxMsg.Len);
					if (RxMsg.Len>0){
						printf(",Data=");
						for (i=0;i<RxMsg.Len;i++)
						{
							printf("%02X",RxMsg.Data[i]);
							if (i!=RxMsg.Len-1) printf(",");
						}
					}
				printf("\n");
				}
			}
		}
    //Get CAN Message
    
    
    //Check I-8120 State
    /*I8120_Status(SlotNo , &status);
    if (Ret){
      if (Ret!=CAN8K_FIFO_EMPTY){
      	printf("Receive Message Error, Error Code=%d.\n",Ret);
      	break;
      }
    }
    if (CANRegStatus!=OldCANRegStatus){
    	printf("CANRegStatus=%02x.\n",CANRegStatus);
    	OldCANRegStatus=CANRegStatus;
    }
    if (OverFlowStatus!=OldOverFlowStatus){
    	printf("OverFlowStatus=%02x.\n",OverFlowStatus);
    	OldOverFlowStatus=OverFlowStatus;
    }*/
	//sleep(1);
  }

  Ret=I8120_RestoreI8120(SlotNo);
  if(Ret)
	  printf("reset fail!!");
  Close_Slot(SlotNo);
  printf("Exit Program.\n");
  return 0;
}
