﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using I8120net_PAC;

namespace SendCyclicMsg
{
    public partial class Form1 : Form
    {
        byte Slot;
        byte Baud;
        byte t_Rtr, t_Mode, t_Dlen, t_CyclicCnt;
        byte [] t_Handle = new byte [8];
        string StrText="";
        static Object ThisLock = new Object(); //This is used to avoid mulit-accessing the same I-8120W
        //in the different functions or threads simultaneously. It is useless 
        //while the functions or threads access the I-8120W with different slot.

        public Form1()
        {
            InitializeComponent();
        }

        private void Btn_Disable_Click(object sender, EventArgs e)
        {
            int Ret, Item_Index;
            byte Temp_Handle, Temp_Cnt;

            if (t_CyclicCnt == 0)
            {
                StrText = String.Format("No cyclic tramsmission messages Err can be disable");
                MessageBox.Show(StrText);
                return;
            }

            if (List_Msg.SelectedItem == null) return;

            Temp_Cnt = Convert.ToByte(List_Msg.Text.Substring(1, 1));
            if ((Temp_Cnt > 5) || (Temp_Cnt < 0)) return;

            Temp_Handle = t_Handle[Temp_Cnt];
            lock (ThisLock)
            {
                //This is used to avoid mulit-accessing the same I-8120W
                //in the different functions or threads simultaneously. It is useless 
                //while the functions or threads access the I-8120W with different slot.
                Ret = I8120.I8120_DisableCyclicTxMsg(Slot, Temp_Handle);  //Disable selected cyclic transmission message.
            }
            if (Ret != 0)
            {
                StrText = String.Format("I-8120 Enable Cyclic Messages Err = {0:D}", Ret);
                MessageBox.Show(StrText);
                return;
            }

            StrText = List_Msg.Text;
            StrText = StrText.Replace("Enable", "Disable");
            Item_Index = List_Msg.SelectedIndex;
            List_Msg.Items[Item_Index] = StrText;
        }

        private void Btn_Enable_Click(object sender, EventArgs e)
        {
            int Ret, Item_Index;
            UInt32 CntValue;
            byte Temp_Handle, Temp_Cnt;

            if (t_CyclicCnt == 0)
            {
                StrText = String.Format("No cyclic tramsmission messages Err can be enable");
                MessageBox.Show(StrText);
                return;
            }

            if (List_Msg.SelectedItem == null) return;
            
            Temp_Cnt = Convert.ToByte(List_Msg.Text.Substring(1, 1));
            if ((Temp_Cnt > 5) || (Temp_Cnt < 0)) return;

            Temp_Handle = t_Handle[Temp_Cnt];
            lock (ThisLock)
            {
                Ret = I8120.I8120_EnableCyclicTxMsg(Slot, Temp_Handle);  //Enable selected cyclic transmission message.
            }
            if (Ret != 0)
            {
                StrText = String.Format("I-8120 Enable Cyclic Messages Err = {0:D}", Ret);
                MessageBox.Show(StrText);
                return;
            }

            StrText = List_Msg.Text;
            StrText = StrText.Replace("Disable", "Enable");
            CntValue = Convert.ToUInt32(StrText.Substring(StrText.IndexOf("Times=") + 6, StrText.IndexOf(",Enable")  - (StrText.IndexOf("Times=")  + 6)));
            if (CntValue > 0)
            {
                StrText = StrText + ",Cnt:" + CntValue.ToString();
            }
            Item_Index = List_Msg.SelectedIndex;
            List_Msg.Items[Item_Index] = StrText;
        }

        private void Btn_Del_Click(object sender, EventArgs e)
        {
            int Ret;
            byte Temp_Handle, Temp_Cnt;

            if (t_CyclicCnt == 0)
            {
                StrText = String.Format("No cyclic tramsmission messages Err can be delete");
                MessageBox.Show(StrText);
                return;
            }

            if (List_Msg.SelectedItem == null) return;

            Temp_Cnt = Convert.ToByte(List_Msg.Text.Substring(1, 1));
            if ((Temp_Cnt > 5) || (Temp_Cnt < 0)) return;

            Temp_Handle = t_Handle[Temp_Cnt];
            lock (ThisLock)
            {
                Ret = I8120.I8120_DeleteCyclicTxMsg(Slot, Temp_Handle);  //Delete selected cyclic transmission message
            }
            if (Ret != 0)
            {
                StrText = String.Format("I-8120 Delete Cyclic Messages Err = {0:D}", Ret);
                MessageBox.Show(StrText);
                return;
            }

            List_Msg.Items.Remove(List_Msg.SelectedItem);
            t_CyclicCnt = Convert.ToByte(t_CyclicCnt - 1);
        }

        private void Btn_Add_Click(object sender, EventArgs e)
        {
            int Ret, i;
            byte [] Data = new byte [8];
            uint t_ID, TimePeriod, Counter;
            string Str_Data, Str_ID;

            t_ID = Convert.ToUInt32(Text_ID.Text,16);
            t_Dlen = Convert.ToByte(Combo_Len.Text);
            Data[0] = Convert.ToByte(Text_D0.Text, 16);
            Data[1] = Convert.ToByte(Text_D1.Text, 16);
            Data[2] = Convert.ToByte(Text_D2.Text, 16);
            Data[3] = Convert.ToByte(Text_D3.Text, 16);
            Data[4] = Convert.ToByte(Text_D4.Text, 16);
            Data[5] = Convert.ToByte(Text_D5.Text, 16);
            Data[6] = Convert.ToByte(Text_D6.Text, 16);
            Data[7] = Convert.ToByte(Text_D7.Text, 16);

            TimePeriod = Convert.ToUInt32(Text_Peri.Text);
            Counter =  Convert.ToUInt32(Text_Cnt.Text);
            
            //Add cyclic transmission message
            lock (ThisLock)
            {
                Ret = I8120.I8120_AddCyclicTxMsg(Slot, t_Mode, t_ID, t_Rtr, t_Dlen, Data, TimePeriod, Counter, out t_Handle[t_CyclicCnt]);
            }
            if (Ret != 0)
            {
                StrText = String.Format("I-8120 Add Cyclic Messages Err = {0:D}", Ret);
                MessageBox.Show(StrText);
                return;
            }
            
            if (t_Rtr != 0)
            {
                if (t_Mode != 0)
                {
                    Str_ID = "["+ t_Handle[t_CyclicCnt].ToString("D") + "] 2.0B,ID=" + t_ID.ToString("X8") + ",RTR=Y,L=" + t_Dlen.ToString() + ",Period=" +  TimePeriod.ToString() + ",Times=" + Counter.ToString() + ",Disable";
                    List_Msg.Items.Add(Str_ID);
                }
                else
                {
                    Str_ID = "[" + t_Handle[t_CyclicCnt].ToString("D") + "] 2.0A,ID=" + t_ID.ToString("X3") + ",RTR=Y,L=" + t_Dlen.ToString() + ",Period=" + TimePeriod.ToString() + ",Times=" + Counter.ToString() + ",Disable";
                    List_Msg.Items.Add(Str_ID);
                }
            }
            else
            {
                Str_Data = "";
                for(i=0;i<t_Dlen;i++)
                {
                    Str_Data = Str_Data + " " + Data[i].ToString("X2");
                }
                if (t_Dlen != 0)
                {
                    Str_Data = ",Data=" + Str_Data;
                }
                if (t_Mode != 0)
                {
                    Str_ID = "[" + t_Handle[t_CyclicCnt].ToString("D") + "] 2.0B,ID=" + t_ID.ToString("X8") + ",RTR=N,L=" + t_Dlen.ToString() + Str_Data + ",Period=" + TimePeriod.ToString() + ",Times=" + Counter.ToString() + ",Disable";
                    List_Msg.Items.Add(Str_ID);
                }
                else
                {
                    Str_ID = "[" + t_Handle[t_CyclicCnt].ToString("D") + "] 2.0A,ID=" + t_ID.ToString("X3") + ",RTR=N,L=" + t_Dlen.ToString() +  Str_Data + ",Period=" + TimePeriod.ToString() + ",Times=" + Counter.ToString() + ",Disable";
                    List_Msg.Items.Add(Str_ID);
                }
            }

            t_CyclicCnt = Convert.ToByte(t_CyclicCnt + 1);
        }

        private void Combo_Len_SelectedIndexChanged(object sender, EventArgs e)
        {
            t_Dlen = Convert.ToByte(Combo_Len.SelectedIndex);
        }

        private void Check_RTR_CheckStateChanged(object sender, EventArgs e)
        {
            if (Check_RTR.Checked == true)
            {
                t_Rtr = 1;
            }
            else
            {
                t_Rtr = 0;
            }
        }

        private void ID_Bit29_CheckedChanged(object sender, EventArgs e)
        {
            if (ID_Bit29.Checked == true)
            {
                ID_Bit11.Checked = false;
                t_Mode = 1;
                Text_ID.MaxLength = 8;
                Text_ID.Text = "1FFFFFFF";
            }
        }

        private void ID_Bit11_CheckedChanged(object sender, EventArgs e)
        {
            if (ID_Bit11.Checked == true)
            {
                ID_Bit29.Checked = false;
                t_Mode = 0;
                Text_ID.MaxLength = 3;
                Text_ID.Text = "7FF";
            }
        }

        private void Btn_Init_Click(object sender, EventArgs e)
        {
            int Ret;

            lock (ThisLock)
            {
                Ret = I8120.I8120_Init(Slot);
            }
            if (Ret != 0)
            {
                StrText = String.Format("I-8120 Init Err = {0:D}", Ret);
                MessageBox.Show(StrText);
                return;
            }

            lock (ThisLock)
            {
                Ret = I8120.I8120_HardwareReset(Slot);
            }
            if (Ret != 0)
            {
                StrText = String.Format("I-8120 HardwareReset Err = {0:D}", Ret);
                MessageBox.Show(StrText);
                return;
            }

            lock (ThisLock)
            {
                Ret = I8120.I8120_ConfigWithoutStruct(Slot, 0, Convert.ToUInt32(0xFFFFFFFF), Baud, 0, 0);
            }
            if (Ret != 0)
            {
                StrText = String.Format("I-8120 Config Err = {0:D}", Ret);
                MessageBox.Show(StrText);
                return;
            }

            Btn_Init.Enabled = false;
            Btn_Add.Enabled = true;
            Btn_Del.Enabled = true;
            Btn_Enable.Enabled = true;
            Btn_Disable.Enabled = true;
            timer1.Enabled=true;
        }

        private void Combo_Baud_SelectedIndexChanged(object sender, EventArgs e)
        {
            Baud = Convert.ToByte(Combo_Baud.SelectedIndex + 1);
        }

        private void Combo_Slot_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (Slot != Convert.ToByte(Combo_Slot.SelectedIndex))
            {
                lock (ThisLock)
                {
                    I8120.I8120_RestoreI8120(Slot);
                }
                Slot = Convert.ToByte(Combo_Slot.SelectedIndex);
                Btn_Init.Enabled = true;
                Btn_Add.Enabled = false;
                Btn_Del.Enabled = false;
                Btn_Enable.Enabled = false;
                Btn_Disable.Enabled = false;
                timer1.Enabled=false;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Btn_Init.Enabled = true;
            Btn_Add.Enabled = false;
            Btn_Del.Enabled = false;
            Btn_Enable.Enabled = false;
            Btn_Disable.Enabled = false;

            Text_ID.MaxLength = 3;
            Combo_Slot.SelectedIndex = 0;
            Combo_Baud.SelectedIndex = 7;
            Combo_Len.SelectedIndex = 0;
            ID_Bit11.Checked = true;
            ID_Bit29.Checked = false;
            Check_RTR.Checked = false;

            Slot = 0;
            Baud = 8;

            t_Rtr = 0;
            t_Mode = 0;
            t_Dlen = 0;
            t_CyclicCnt = 0;
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            lock (ThisLock)
            {
                I8120.I8120_RestoreI8120(Slot);
            }
        }

        private void Text_ID_TextChanged(object sender, EventArgs e)
        {
            if (t_Mode == 1)
            {
                if (Convert.ToUInt32(Text_ID.Text, 16) > 0x1FFFFFFF)
                {
                    Text_ID.Text = "1FFFFFFF";
                }
            }
            else
            {
                if (Convert.ToUInt32(Text_ID.Text, 16) > 0x7FF)
                {
                    Text_ID.Text = "7FF";
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            uint RestCnt,SendCnt;
            int Ret, i, SubStrLen1, SubStrLen2;
            Byte  SelectedHandle;
            String TempStr;
            

            if (t_CyclicCnt != 0)
            {
                for ( i = 0 ; i<t_CyclicCnt ; i++)
                {
                    TempStr = List_Msg.Items[i].ToString();
                    SelectedHandle = Convert.ToByte(TempStr.Substring(1, 1));
                    if ((SelectedHandle < 5) && (SelectedHandle >= 0))
                    {
                        SubStrLen2 = TempStr.IndexOf(",Enable");
                        if (SubStrLen2 > 0)
                        {
                            SubStrLen1 = TempStr.IndexOf("Times=");
                            SendCnt = Convert.ToUInt32(TempStr.Substring(SubStrLen1 + 6, SubStrLen2 - (SubStrLen1 + 6)));
                            if (SendCnt > 0)
                            {
                                lock (ThisLock)
                                {
                                    Ret = I8120.I8120_CheckCyclicTxRestMsg(Slot, SelectedHandle, out RestCnt); //Disable selected cyclic transmission message.
                                }
                                if (Ret.Equals(0))
                                {
                                    if (RestCnt.Equals (0))
                                    {
                                        TempStr = TempStr.Replace("Enable", "Disable");
                                        TempStr = TempStr.Substring(0, TempStr.IndexOf(",Cnt:"));
                                        List_Msg.Items[i] = TempStr;
                                    }
                                    else
                                    {
                                        TempStr = TempStr.Substring(0, TempStr.IndexOf(",Cnt:") + 5) + RestCnt.ToString();
                                        List_Msg.Items[i] = TempStr;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}