Imports I8120net_PAC

Public Class Form1
    Const MAX_LINE = 1000
    Dim Slot As Byte
    Dim Baud As Byte
    Dim TimerEnable As Byte
    Dim LineCnt As Integer

    Private Sub Combo_Slot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Slot.SelectedIndexChanged
        If (Slot <> Combo_Slot.SelectedIndex) Then
            SyncLock Me
                'This is used to avoid mulit-accessing the same I-8120W
                'in the different functions or threads simultaneously. It is useless 
                'while the functions or threads access the I-8120W with different slot.
                I8120.I8120_RestoreI8120(Slot)
            End SyncLock
            Btn_Init.Enabled = True
            Btn_Pause.Enabled = False
            Btn_Clear.Enabled = False
            Timer1.Enabled = False
            TimerEnable = 0
            Slot = Combo_Slot.SelectedIndex
        End If
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged
        Baud = Combo_Baud.SelectedIndex + 1
    End Sub

    Private Sub Btn_Init_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Init.Click
        Dim Ret As Integer

        Slot = Combo_Slot.SelectedIndex

        SyncLock Me
            Ret = I8120.I8120_Init(Slot)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 Init Err = " + Str(Ret))
            Exit Sub
        End If

        SyncLock Me
            Ret = I8120.I8120_HardwareReset(Slot)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 HardwareReset Err = " + Str(Ret))
            Exit Sub
        End If

        SyncLock Me
            Ret = I8120.I8120_ConfigWithoutStruct(Slot, 0, 4294967295, Baud, 0, 0)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 HardwareReset Err = " + Str(Ret))
            Exit Sub
        End If

        Btn_Init.Enabled = False

        Btn_Pause.Enabled = True
        Btn_Clear.Enabled = True

        Timer1.Enabled = True
        TimerEnable = 1
        LineCnt = 0
    End Sub

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        SyncLock Me
            I8120.I8120_RestoreI8120(Slot)
        End SyncLock
        Timer1.Enabled = False
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Btn_Init.Enabled = True

        Btn_Pause.Enabled = False
        Btn_Clear.Enabled = False

        Combo_Slot.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 7

        Slot = 0
        Baud = 8
    End Sub

    Private Sub Btn_Pause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Pause.Click
        If (TimerEnable = 1) Then
            TimerEnable = 0
            Timer1.Enabled = False
            Btn_Pause.Text = "Go"
        Else
            TimerEnable = 1
            Timer1.Enabled = True
            Btn_Pause.Text = "Pause"
        End If
    End Sub

    Private Sub Btn_Clear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Clear.Click
        List_Msg.Items.Clear()
        LineCnt = 0
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim TempCANReg As Byte, TempOverflowFlag As Byte
        Dim Mode As Byte, RTR As Byte, DataLen As Byte, Data(8) As Byte
        Dim Ret As Integer, i As Integer, j As Integer, Cnt As Integer
        Dim ID As Long, UpperTimeStamp As Long, LowerTimeStamp As Long
        Dim TimeStamp As Int64
        Dim Str_Data As String, Str_ID As String
        Dim ID_Len As Byte

        'Get I-8120W status from I-8120W module
        SyncLock Me
            Ret = I8120.I8120_Status(Slot, TempCANReg)
        End SyncLock
        If (Ret <> 0) Then
            Timer1.Enabled = False
            TimerEnable = 0
            MessageBox.Show("Get Status Error = " + Str(Ret))
            Exit Sub
        End If

        'Get CAN message from I-8120W
        SyncLock Me
            Ret = I8120.I8120_RxMsgCount(Slot, Cnt)
        End SyncLock
        If (Ret) Then
            Timer1.Enabled = False
            TimerEnable = 0
            MessageBox.Show("Get Message count Error = " + Str(Ret))
            Exit Sub
        End If

        If (Cnt <> 0) Then
            For i = 0 To Cnt - 1
                SyncLock Me
                    Ret = I8120.I8120_ReceiveWithoutStruct(Slot, Mode, ID, RTR, DataLen, Data, UpperTimeStamp, LowerTimeStamp)
                End SyncLock
                If (Ret <> 0) Then
                    If (Ret = 22) Then
                        TempOverflowFlag = TempOverflowFlag Or &H1
                    Else
                        Timer1.Enabled = False
                        TimerEnable = 0
                        MessageBox.Show("Get Message count Error = " + Str(Ret))
                        Exit Sub
                    End If
                Else    'Show the receive CAN message information in the list control object
                    TempOverflowFlag = TempOverflowFlag And &HFE
                    TimeStamp = UpperTimeStamp
                    TimeStamp = TimeStamp * 4294967296
                    TimeStamp = TimeStamp + LowerTimeStamp

                    ID_Len = Hex(ID).Length
                    Str_ID = ""
                    If (RTR <> 0) Then
                        If (Mode <> 0) Then
                            For j = 1 To (8 - ID_Len)
                                Str_ID = Str_ID + "0"
                            Next
                            Str_ID = Str_ID + Hex(ID)
                            List_Msg.Items.Add(Format(LineCnt, "000") + " 2.0B " + Str_ID + " Y " + Str(DataLen) + " " + Str(TimeStamp))
                        Else
                            Str_ID = "        "
                            For j = 1 To (3 - ID_Len)
                                Str_ID = Str_ID + "0"
                            Next
                            Str_ID = Str_ID + Hex(ID)
                            List_Msg.Items.Add(Format(LineCnt, "000") + " 2.0A " + Str_ID + " Y " + Str(DataLen) + " " + Str(TimeStamp))
                        End If

                    Else
                        Str_Data = " "
                        For j = 0 To DataLen - 1
                            If (Data(j) > &HF) Then
                                Str_Data = Str_Data + Hex(Data(j)) + " "
                            Else
                                Str_Data = Str_Data + "0" + Hex(Data(j)) + " "
                            End If
                        Next

                        If (Mode <> 0) Then
                            For j = 1 To (8 - ID_Len)
                                Str_ID = Str_ID + "0"
                            Next
                            Str_ID = Str_ID + Hex(ID)
                            List_Msg.Items.Add(Format(LineCnt, "000") + " 2.0B " + Str_ID + " N " + Str(DataLen) + Str_Data + Str(TimeStamp))
                        Else
                            Str_ID = "        "
                            For j = 1 To (3 - ID_Len)
                                Str_ID = Str_ID + "0"
                            Next
                            Str_ID = Str_ID + Hex(ID)
                            List_Msg.Items.Add(Format(LineCnt, "000") + " 2.0A " + Str_ID + " N " + Str(DataLen) + Str_Data + Str(TimeStamp))
                        End If
                    End If
                    List_Msg.SelectedIndex = LineCnt
                    LineCnt = LineCnt + 1
                End If

                If (LineCnt = MAX_LINE) Then
                    List_Msg.Items.Clear()
                    LineCnt = 0
                End If
            Next
        End If

        If (TempCANReg > &HF) Then
            Lab_Status.Text = "0x"
        Else
            Lab_Status.Text = "0x0"
        End If
        Lab_Status.Text = Lab_Status.Text + Hex(TempCANReg)
        Lab_Overflow.Text = "0x0" + Hex(TempOverflowFlag)
    End Sub
End Class
