Imports I8120net_PAC

Public Class Form1
    Dim Slot As Byte
    Dim Baud As Byte

    Dim t_Rtr As Byte
    Dim t_Mode As Byte

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        SyncLock Me
            'This is used to avoid mulit-accessing the same I-8120W
            'in the different functions or threads simultaneously. It is useless 
            'while the functions or threads access the I-8120W with different slot.
            I8120.I8120_RestoreI8120(Slot)
        End SyncLock

        Timer1.Enabled = False
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Combo_Slot.Enabled = True
        Combo_Baud.Enabled = True
        Btn_Init.Enabled = True
        Send_Panel.Enabled = False

        Combo_Slot.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 7

        ID_Bit11.Checked = True
        ID_Bit29.Checked = False
        Check_RTR.Checked = False

        Slot = 0
        Baud = 8

        t_Rtr = 0
        t_Mode = 0
        Text_Len.MaxLength = 1
        Text_Len.Text = "8"
        Text_ID.MaxLength = 3
        Text_ID.Text = "7FF"
        Text_Data.MaxLength = 24
        Text_Data.Text = "11 22 33 44 55 66 77 88"
    End Sub

    Private Sub Btn_Init_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Init.Click
        Dim Ret As Integer

        Slot = Combo_Slot.SelectedIndex

        SyncLock Me
            Ret = I8120.I8120_Init(Slot)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 Init Err = " + Str(Ret))
            Exit Sub
        End If

        SyncLock Me
            Ret = I8120.I8120_HardwareReset(Slot)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 HardwareReset Err = " + Str(Ret))
            Exit Sub
        End If

        SyncLock Me
            Ret = I8120.I8120_ConfigWithoutStruct(Slot, 0, 4294967295, Baud, 0, 0)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 Config Err = " + Str(Ret))
            Exit Sub
        End If

        Btn_Init.Enabled = False
        Send_Panel.Enabled = True
        Timer1.Enabled = True
    End Sub

    Private Sub Combo_Slot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Slot.SelectedIndexChanged
        If (Slot <> Combo_Slot.SelectedIndex) Then
            SyncLock Me
                I8120.I8120_RestoreI8120(Slot)
            End SyncLock
            Btn_Init.Enabled = True
            Send_Panel.Enabled = False
            Timer1.Enabled = False
            Slot = Combo_Slot.SelectedIndex
        End If
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged
        Baud = Combo_Baud.SelectedIndex + 1
    End Sub

    Private Sub Check_RTR_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Check_RTR.CheckStateChanged
        If (Check_RTR.Checked = True) Then
            t_Rtr = 1
        Else
            t_Rtr = 0
        End If
    End Sub

    Private Sub ID_Bit11_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ID_Bit11.CheckedChanged
        If (ID_Bit11.Checked = True) Then
            ID_Bit29.Checked = False
            t_Mode = 0
            Text_ID.MaxLength = 3
            Text_ID.Text = "7FF"
        End If
    End Sub

    Private Sub ID_Bit29_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ID_Bit29.CheckedChanged
        If (ID_Bit29.Checked = True) Then
            ID_Bit11.Checked = False
            t_Mode = 1
            Text_ID.MaxLength = 8
            Text_ID.Text = "1FFFFFFF"
        End If
    End Sub

    Private Sub Btn_Send_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Send.Click
        Dim Ret As Integer
        Dim t_ID As Long
        Dim t_Dlen As Byte
        Dim t_Data(8) As Byte


        t_ID = Val("&H" + Text_ID.Text)
        t_Dlen = Val(Text_Len.Text)
        t_Data(0) = Val("&H" + Text_Data.Text.Substring(0, 2))
        t_Data(1) = Val("&H" + Text_Data.Text.Substring(3, 2))
        t_Data(2) = Val("&H" + Text_Data.Text.Substring(6, 2))
        t_Data(3) = Val("&H" + Text_Data.Text.Substring(9, 2))
        t_Data(4) = Val("&H" + Text_Data.Text.Substring(12, 2))
        t_Data(5) = Val("&H" + Text_Data.Text.Substring(15, 2))
        t_Data(6) = Val("&H" + Text_Data.Text.Substring(18, 2))
        t_Data(7) = Val("&H" + Text_Data.Text.Substring(21, 2))

        SyncLock Me
            Ret = I8120.I8120_SendWithoutStruct(Slot, t_Mode, t_ID, t_Rtr, t_Dlen, t_Data)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 Send Message Err = " + Str(Ret))
            Exit Sub
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim Ret As Integer
        Dim TxStatus As Byte

        SyncLock Me
            Ret = I8120.I8120_IsTxTimeout(Slot, TxStatus)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 check is Tx Timeout Err = " + Str(Ret))
            Timer1.Enabled = False
            Exit Sub
        End If

        If (TxStatus <> 0) Then
            Lab_Send.Text = "Timeout !"
        Else
            Lab_Send.Text = "Send OK"
        End If
    End Sub

    Private Sub Text_ID_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Text_ID.TextChanged
        If (t_Mode = 1) Then
            If (Val(Text_ID.Text) > &H1FFFFFFF) Then
                Text_ID.Text = "1FFFFFFF"
            End If
        Else
            If (Val(Text_ID.Text) > &H7FF) Then
                Text_ID.Text = "7FF"
            End If
        End If
    End Sub

    Private Sub Text_Len_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Text_Len.TextChanged
        If (Val(Text_Len.Text) > 8) Then
            Text_ID.Text = "8"
        End If
    End Sub
End Class
