// RecMsgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RecMsg.h"
#include "RecMsgDlg.h"
#include "I8120.h"

#define MAX_LINE 1000

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRecMsgDlg dialog
CRITICAL_SECTION  AccessI8120W_cs; //The critical section is used to avoid mulit-accessing the same I-8120W
                                   //in the different functions or threads simultaneously. It is useless 
                                   //while the functions or threads access the I-8120W with different slot.
CRecMsgDlg::CRecMsgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRecMsgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRecMsgDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRecMsgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRecMsgDlg)
	DDX_Control(pDX, IDC_OVERFLOW_STATIC, m_OverFlow);
	DDX_Control(pDX, IDC_STATUS_STATIC, m_CANStatus);
	DDX_Control(pDX, IDC_SLOT_COMBO, m_Slot);
	DDX_Control(pDX, IDC_RUN_BUTTON, m_Run);
	DDX_Control(pDX, IDC_MSG_LIST_CTRL, m_MsgListCtrl);
	DDX_Control(pDX, IDC_INIT_BUTTON, m_Init);
	DDX_Control(pDX, IDC_BAUD_COMBO, m_Baud);
	DDX_Control(pDX, IDC_CLEAR_BUTTON, m_Clear);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRecMsgDlg, CDialog)
	//{{AFX_MSG_MAP(CRecMsgDlg)
	ON_CBN_SELENDOK(IDC_SLOT_COMBO, OnSelendokSlotCombo)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CLEAR_BUTTON, OnClearButton)
	ON_BN_CLICKED(IDC_INIT_BUTTON, OnInitButton)
	ON_BN_CLICKED(IDC_RUN_BUTTON, OnRunButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRecMsgDlg message handlers

WORD OldSlotSelect=0,TimerEnable,MsgFormat,LineCnt;
BYTE OldCANReg=0,OldOverflogFlag;

void CRecMsgDlg::FormInit(void)
{
	//Initiate all objects and parameters used in the dialog
	m_Run.EnableWindow(FALSE);
	m_Clear.EnableWindow(FALSE);
	m_CANStatus.SetWindowText(_T("****"));
	if (TimerEnable) KillTimer(12345);
	TimerEnable=0;
	LineCnt=0;
}

BOOL CRecMsgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	//initial button
	m_Run.EnableWindow(FALSE);
	m_CANStatus.SetWindowText(_T("****"));
	
	//initial button
	FormInit();
		
	//parameter initialize
	m_Slot.InsertString(0,_T(" Slot 0"));
	m_Slot.InsertString(1,_T(" Slot 1"));
	m_Slot.InsertString(2,_T(" Slot 2"));
	m_Slot.InsertString(3,_T(" Slot 3"));
	m_Slot.InsertString(4,_T(" Slot 4"));
	m_Slot.InsertString(5,_T(" Slot 5"));
	m_Slot.InsertString(6,_T(" Slot 6"));
	m_Slot.InsertString(7,_T(" Slot 7"));
	m_Slot.SetCurSel(0);
	m_Baud.InsertString(0,_T("   10K bps  "));
	m_Baud.InsertString(1,_T("   20K bps  "));
	m_Baud.InsertString(2,_T("   50K bps  "));
	m_Baud.InsertString(3,_T("  125K bps  "));
	m_Baud.InsertString(4,_T("  250K bps  "));
	m_Baud.InsertString(5,_T("  500K bps  "));
	m_Baud.InsertString(6,_T("  800K bps  "));
	m_Baud.InsertString(7,_T(" 1000K bps  "));
	m_Baud.SetCurSel(7);

	//initiate list control object
	m_MsgListCtrl.InsertColumn(0,_T("NO."),LVCFMT_CENTER,34);
	m_MsgListCtrl.InsertColumn(1,_T("Mode"),LVCFMT_CENTER,42);
	m_MsgListCtrl.InsertColumn(2,_T("ID"),LVCFMT_CENTER,70);
	m_MsgListCtrl.InsertColumn(3,_T("RTR"),LVCFMT_CENTER,34);
	m_MsgListCtrl.InsertColumn(4,_T("L"),LVCFMT_CENTER,19);
	m_MsgListCtrl.InsertColumn(5,_T("D0"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(6,_T("D1"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(7,_T("D2"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(8,_T("D3"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(9,_T("D4"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(10,_T("D5"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(11,_T("D6"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(12,_T("D7"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(13,_T("TimeStamp (100us)"),LVCFMT_CENTER,130);
	
	InitializeCriticalSection(&AccessI8120W_cs);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRecMsgDlg::OnSelendokSlotCombo() 
{
	//Check if the slot combo box is changed or not, and do something for different situation
	if ((m_Slot.GetCurSel())!=OldSlotSelect){
		EnterCriticalSection(&AccessI8120W_cs);
		I8120_RestoreI8120((BYTE)OldSlotSelect);
		LeaveCriticalSection(&AccessI8120W_cs);
		FormInit();
		OldSlotSelect=m_Slot.GetCurSel();
		return;
	}
}

void CRecMsgDlg::OnTimer(UINT nIDEvent) 
{
	BYTE TempCANReg,TempOverflowFlag,Mode,RTR,DataLen,Data[8];
	wchar_t wTempStr[200];
	int Ret,i;
	WORD Cnt;
	DWORD ID,UpperTimeStamp,LowerTimeStamp;
	 
	//Get I-8120W status from I-8120W module
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_Status((BYTE)OldSlotSelect,&TempCANReg);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		FormInit();
		wsprintf(wTempStr,_T("Get Status Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	//Get CAN message from I-8120W
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_RxMsgCount((BYTE)OldSlotSelect,&Cnt);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		FormInit();
		wsprintf(wTempStr,_T("Get Message count Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}
	if (Cnt){
		for (i=0;i<Cnt;i++){
			EnterCriticalSection(&AccessI8120W_cs);
			Ret=I8120_ReceiveWithoutStruct((BYTE)OldSlotSelect,&Mode,&ID,&RTR,&DataLen,Data,&UpperTimeStamp,&LowerTimeStamp);
			LeaveCriticalSection(&AccessI8120W_cs);
			if (Ret){
				if (Ret==I8120_SoftBufferIsFull){
					TempOverflowFlag|=0x0;
				}
				else{
					FormInit();
					wsprintf(wTempStr,_T("Get Message Error, Error Code=%d"),Ret);
					MessageBox(wTempStr,_T("Error"),MB_OK);
					KillTimer(12345);
					TimerEnable=0;
					return;
				}
			}
			else{ //Show the receive CAN message information in the list control object
				TempOverflowFlag&=(~0x01);
				if (RTR){
					CString strText;
					strText.Format(_T("%03d"),LineCnt);
					m_MsgListCtrl.InsertItem(LineCnt,strText);
					m_MsgListCtrl.SetItemText(LineCnt,1,Mode?_T("2.0B"):_T("2.0A"));
					strText.Format(_T("%lX"),ID);
					m_MsgListCtrl.SetItemText(LineCnt,2, strText);
					m_MsgListCtrl.SetItemText(LineCnt,3, RTR?_T("Y"):_T("N"));
					strText.Format(_T("%d"),DataLen);
					m_MsgListCtrl.SetItemText(LineCnt,4, strText);
					strText.Format(_T("%I64d"),(((__int64)UpperTimeStamp<<32)+(__int64)LowerTimeStamp));
					m_MsgListCtrl.SetItemText(LineCnt,13, strText);
				}
				else{
					CString strText;
					strText.Format(_T("%03d"),LineCnt);
					m_MsgListCtrl.InsertItem(LineCnt,strText);
					m_MsgListCtrl.SetItemText(LineCnt,1,Mode?_T("2.0B"):_T("2.0A"));
					strText.Format(_T("%lX"),ID);
					m_MsgListCtrl.SetItemText(LineCnt,2, strText);
					m_MsgListCtrl.SetItemText(LineCnt,3, RTR?_T("Y"):_T("N"));
					strText.Format(_T("%d"),DataLen);
					m_MsgListCtrl.SetItemText(LineCnt,4, strText);
					for (int i=0;i<DataLen;i++){
						strText.Format(_T("%02X"),Data[i]);
						m_MsgListCtrl.SetItemText(LineCnt,5+i, strText);
					}
					strText.Format(_T("%I64d"),(((__int64)UpperTimeStamp<<32)+(__int64)LowerTimeStamp));
					m_MsgListCtrl.SetItemText(LineCnt,13, strText);
				}
				LineCnt++;
				if (LineCnt>5){
					CSize Rolling;
					Rolling.cx=0;
					Rolling.cy=30*(LineCnt-5);
					m_MsgListCtrl.Scroll(Rolling);
				}
				if (LineCnt==MAX_LINE){
					m_MsgListCtrl.DeleteAllItems( ); 
					LineCnt=0;
				}
			}
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CRecMsgDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	//recover the system resource
	EnterCriticalSection(&AccessI8120W_cs);
	I8120_RestoreI8120((BYTE)OldSlotSelect);
	LeaveCriticalSection(&AccessI8120W_cs);
	//recover the timer setting and COM 1 setting
	if (TimerEnable) KillTimer(12345);
}

void CRecMsgDlg::OnClearButton() 
{
	//Clear all information stored in the list control object
	m_MsgListCtrl.DeleteAllItems( ); 
	LineCnt=0;
}

void CRecMsgDlg::OnInitButton() 
{
	wchar_t wTempStr[100];
	BYTE TempBt0=0,TempBt1=0;
	WORD Ret;
	CString TempStr;
	
	OldSlotSelect=m_Slot.GetCurSel();
	//configue the I-8120W setting and initiate the I-8120W
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_Init((BYTE)OldSlotSelect);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		wsprintf(wTempStr,_T("Initiate I-8120W Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_HardwareReset((BYTE)OldSlotSelect);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		wsprintf(wTempStr,_T("Reset I-8120W Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_ConfigWithoutStruct((BYTE)OldSlotSelect,0UL,0xffffffffUL,(m_Baud.GetCurSel()+1),0,0);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		wsprintf(wTempStr,_T("Configure I-8120W Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}
	//start the objects and parameters used in the dialog
	m_Run.EnableWindow(TRUE);
	m_Clear.EnableWindow(TRUE);
	m_CANStatus.SetWindowText(_T("0x0C"));
	m_OverFlow.SetWindowText(_T("0x00"));
	if (!TimerEnable) SetTimer(12345,1,NULL);	
	TimerEnable=1;
}

void CRecMsgDlg::OnRunButton() 
{
	//Let the tiemr stop or continue
	if (TimerEnable){
		m_Run.SetWindowText(_T("Go"));
		KillTimer(12345);
		TimerEnable=0;
	}
	else{
		m_Run.SetWindowText(_T("Pause"));
		SetTimer(12345,1,NULL);
		TimerEnable=1;
	}
}
