// SendCyclicMsgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SendCyclicMsg.h"
#include "SendCyclicMsgDlg.h"
#include "I8120.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSendCyclicMsgDlg dialog
CRITICAL_SECTION  AccessI8120W_cs; //The critical section is used to avoid mulit-accessing the same I-8120W
                                   //in the different functions or threads simultaneously. It is useless 
                                   //while the functions or threads access the I-8120W with different slot.
CSendCyclicMsgDlg::CSendCyclicMsgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSendCyclicMsgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSendCyclicMsgDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSendCyclicMsgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSendCyclicMsgDlg)
	DDX_Control(pDX, IDC_TIME_EDIT, m_time);
	DDX_Control(pDX, IDC_BYTE5_EDIT, m_d5);
	DDX_Control(pDX, IDC_RTR_CHECK, m_rtr);
	DDX_Control(pDX, IDC_SLOT_COMBO, m_slot);
	DDX_Control(pDX, IDC_MSG_LIST, m_msglist);
	DDX_Control(pDX, IDC_ID_EDIT, m_id);
	DDX_Control(pDX, IDC_DLEN_COMBO, m_dlen);
	DDX_Control(pDX, IDC_COUNTER_EDIT, m_counter);
	DDX_Control(pDX, IDC_BYTE7_EDIT, m_d7);
	DDX_Control(pDX, IDC_BYTE6_EDIT, m_d6);
	DDX_Control(pDX, IDC_BYTE4_EDIT, m_d4);
	DDX_Control(pDX, IDC_BYTE3_EDIT, m_d3);
	DDX_Control(pDX, IDC_BYTE2_EDIT, m_d2);
	DDX_Control(pDX, IDC_BYTE1_EDIT, m_d1);
	DDX_Control(pDX, IDC_BYTE0_EDIT, m_d0);
	DDX_Control(pDX, IDC_MODE_RADIO, m_mode);
	DDX_Control(pDX, IDC_BAUD_COMBO, m_baud);
	DDX_Control(pDX, IDC_ADD_BUTTON,m_add);
	DDX_Control(pDX, IDC_DELETE_BUTTON,m_delete);
	DDX_Control(pDX, IDC_ENABLE_BUTTON,m_enable);
	DDX_Control(pDX, IDC_DISABLE_BUTTON,m_disable);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSendCyclicMsgDlg, CDialog)
	//{{AFX_MSG_MAP(CSendCyclicMsgDlg)
	ON_CBN_SELCHANGE(IDC_DLEN_COMBO, OnSelchangeDlenCombo)
	ON_BN_CLICKED(IDC_INIT_BUTTON, OnInitButton)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	ON_BN_CLICKED(IDC_ENABLE_BUTTON, OnEnableButton)
	ON_BN_CLICKED(IDC_DISABLE_BUTTON, OnDisableButton)
	ON_BN_CLICKED(IDC_RTR_CHECK, OnRtrCheck)
	ON_CBN_SELCHANGE(IDC_SLOT_COMBO, OnCbnSelchangeSlotCombo)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendCyclicMsgDlg message handlers

BOOL CSendCyclicMsgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Init all elements on dialog
	m_slot.ResetContent();
	m_slot.InsertString(0,_T(" Slot 0"));
	m_slot.InsertString(1,_T(" Slot 1"));
	m_slot.InsertString(2,_T(" Slot 2"));
	m_slot.InsertString(3,_T(" Slot 3"));
	m_slot.InsertString(4,_T(" Slot 4"));
	m_slot.InsertString(5,_T(" Slot 5"));
	m_slot.InsertString(6,_T(" Slot 6"));
	m_slot.InsertString(7,_T(" Slot 7"));
	m_slot.SetCurSel(0);
	m_baud.ResetContent();
	m_baud.InsertString(0,_T("   10K bps  "));
	m_baud.InsertString(1,_T("   20K bps  "));
	m_baud.InsertString(2,_T("   50K bps  "));
	m_baud.InsertString(3,_T("  125K bps  "));
	m_baud.InsertString(4,_T("  250K bps  "));
	m_baud.InsertString(5,_T("  500K bps  "));
	m_baud.InsertString(6,_T("  800K bps  "));
	m_baud.InsertString(7,_T(" 1000K bps  "));
	m_baud.SetCurSel(7);
	m_dlen.ResetContent(); 
	m_dlen.InsertString(0,_T(" 0 "));
	m_dlen.InsertString(1,_T(" 1 "));
	m_dlen.InsertString(2,_T(" 2 "));
	m_dlen.InsertString(3,_T(" 3 "));
	m_dlen.InsertString(4,_T(" 4 "));
	m_dlen.InsertString(5,_T(" 5 "));
	m_dlen.InsertString(6,_T(" 6 "));
	m_dlen.InsertString(7,_T(" 7 "));
	m_dlen.InsertString(8,_T(" 8 "));
	m_dlen.SetCurSel(8);
	m_mode.SetCheck(true);
	m_id.SetWindowText(_T("7FF"));
	m_id.SetLimitText(8);
	m_d0.SetWindowText(_T("12"));
	m_d0.SetLimitText(2);
	m_d1.SetWindowText(_T("34"));
	m_d1.SetLimitText(2);
	m_d2.SetWindowText(_T("56"));
	m_d2.SetLimitText(2);
	m_d3.SetWindowText(_T("78"));
	m_d3.SetLimitText(2);
	m_d4.SetWindowText(_T("90"));
	m_d4.SetLimitText(2);
	m_d5.SetWindowText(_T("AB"));
	m_d5.SetLimitText(2);
	m_d6.SetWindowText(_T("CD"));
	m_d6.SetLimitText(2);
	m_d7.SetWindowText(_T("EF"));
	m_d7.SetLimitText(2);
	m_time.SetWindowText(_T("10000"));
	m_time.SetLimitText(10);
	m_counter.SetWindowText(_T("1"));
	m_counter.SetLimitText(10);
	this->OnSelchangeDlenCombo();
	m_msglist.SetExtendedStyle(LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES); //Init List Control element
	m_msglist.InsertColumn(0,_T("Handle No."),LVCFMT_CENTER,75);
	m_msglist.InsertColumn(1,_T("Mode"),LVCFMT_CENTER,60);
	m_msglist.InsertColumn(2,_T("ID"),LVCFMT_CENTER,75);
	m_msglist.InsertColumn(3,_T("RTR"),LVCFMT_CENTER,35);
	m_msglist.InsertColumn(4,_T("DLen"),LVCFMT_CENTER,40);
	m_msglist.InsertColumn(5,_T("D0"),LVCFMT_CENTER,32);
	m_msglist.InsertColumn(6,_T("D1"),LVCFMT_CENTER,32);
	m_msglist.InsertColumn(7,_T("D2"),LVCFMT_CENTER,32);
	m_msglist.InsertColumn(8,_T("D3"),LVCFMT_CENTER,32);
	m_msglist.InsertColumn(9,_T("D4"),LVCFMT_CENTER,32);
	m_msglist.InsertColumn(10,_T("D5"),LVCFMT_CENTER,32);
	m_msglist.InsertColumn(11,_T("D6"),LVCFMT_CENTER,32);
	m_msglist.InsertColumn(12,_T("D7"),LVCFMT_CENTER,32);
	m_msglist.InsertColumn(13,_T("Time (0.1ms)"),LVCFMT_CENTER,90);
	m_msglist.InsertColumn(14,_T("Counter"),LVCFMT_CENTER,80);
	m_msglist.InsertColumn(15,_T("Status"),LVCFMT_CENTER,58);
	m_add.EnableWindow(FALSE);
	m_delete.EnableWindow(FALSE);
	m_enable.EnableWindow(FALSE);
	m_disable.EnableWindow(FALSE);

	InitializeCriticalSection(&AccessI8120W_cs);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSendCyclicMsgDlg::OnSelchangeDlenCombo() 
{
	// TODO: Add your control notification handler code here
	int i,DataLen;
	CEdit *TempEdit[8]={&m_d0,&m_d1,&m_d2,&m_d3,&m_d4,&m_d5,&m_d6,&m_d7};

	if (m_rtr.GetCheck()) return;
	DataLen=m_dlen.GetCurSel();
	for (i=0;i<8;i++){
		if (i<DataLen) TempEdit[i]->EnableWindow(true);
		else TempEdit[i]->EnableWindow(false);
	}	
}

static BYTE SelectedSlotNo=0;
static bool IsInitFlag=false;
static BYTE Handle[5];
static BYTE CyclicTxMsgCnt;
void CSendCyclicMsgDlg::OnInitButton() 
{
	// TODO: Add your control notification handler code here
	BYTE SlotNo,Baud;
	int Ret;
	CString ErrStr;

	SlotNo=m_slot.GetCurSel();
	Baud=m_baud.GetCurSel()+1;
	if (IsInitFlag){ //If board is active before, close it first.
		m_msglist.DeleteAllItems();
		CyclicTxMsgCnt=0;
		IsInitFlag=false;
	}

	EnterCriticalSection(&AccessI8120W_cs);
	Ret = I8120_Init(SlotNo);  //Init board
	LeaveCriticalSection(&AccessI8120W_cs);
	if(Ret){
		ErrStr.Format(_T("Initiate Error, Error Code %d"), Ret);
		MessageBox(ErrStr);
		return;
	}

	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_HardwareReset(SlotNo);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		ErrStr.Format(_T("Hardware Reset Error, Error Code %d"), Ret);
		MessageBox(ErrStr);
		return;
	}

	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_ConfigWithoutStruct(SlotNo,0x0UL,0xffffffffUL,Baud,0,0); //Configure board parameters
	LeaveCriticalSection(&AccessI8120W_cs);
	if(Ret){
		ErrStr.Format(_T("Configure Error, Error Code %d"), Ret);
		MessageBox(ErrStr);
		return;
	}
	SelectedSlotNo=SlotNo;
	IsInitFlag=true;
	m_add.EnableWindow(TRUE);
	m_delete.EnableWindow(TRUE);
	m_enable.EnableWindow(TRUE);
	m_disable.EnableWindow(TRUE);
	SetTimer(12345,1,NULL);
}

void CSendCyclicMsgDlg::OnAddButton() 
{
	// TODO: Add your control notification handler code here
	wchar_t* endtemp,TempArr[20];
	int i,Ret;
	DWORD TempValue,MsgID,TimePeriod,Counter;
	CString TempStr;
	BYTE Mode,RTR,DataLen,Data[8];
	CEdit *TempEdit[8]={&m_d0,&m_d1,&m_d2,&m_d3,&m_d4,&m_d5,&m_d6,&m_d7};

	if (CyclicTxMsgCnt>4){
		MessageBox(_T("Only 5 cyclic tramsmission messages are allowed"));
		return;
	}

	UpdateData(true);  //Get parameters from dialog

	m_id.GetWindowText(TempArr,10); //Get message id parameter
	TempValue=_tcstoul(TempArr,&endtemp,16);
	if (m_mode.GetCheck()){ //Check the CAN message mode
		Mode=0;
		MsgID=TempValue&0x7ffUL;
	}
	else{
		Mode=1;
		MsgID=TempValue&0x1fffffffUL;
	}
	TempStr.Format(_T("%lX"),MsgID);
	m_id.SetWindowText(TempStr); //Set message id parameter back to Edit box

	if (m_rtr.GetCheck()) RTR=1; //Check if the RTR is used or not
	else RTR=0;
	
	DataLen=m_dlen.GetCurSel(); //Get data length parameter

	for (i=0;i<8;i++){
		TempEdit[i]->GetWindowText(TempArr,10); //Get data parameters
		TempValue=_tcstoul(TempArr,&endtemp,16);
		Data[i]=(BYTE)(TempValue&0xff);
		TempStr.Format(_T("%02X"),Data[i]);
		TempEdit[i]->SetWindowText(TempStr); //Set data parameters back to Edit box
	}

	m_time.GetWindowText(TempArr,10); //Get time period parameter
	TimePeriod=_tcstoul(TempArr,&endtemp,10);

	m_counter.GetWindowText(TempArr,10); //Get time period parameter
	Counter=_tcstoul(TempArr,&endtemp,10);
	
	if (TimePeriod<5) TimePeriod=5;
	TempStr.Format(_T("%lu"),TimePeriod);
	m_time.SetWindowText(TempStr);  //Set time period parameter back to Edit box

	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_AddCyclicTxMsg(SelectedSlotNo,Mode,MsgID,RTR,DataLen,Data,TimePeriod,Counter,&Handle[CyclicTxMsgCnt]); //Add cyclic transmission message
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		CString ErrStr;
		ErrStr.Format(_T("Add Cyclic Messages Error, Error Code %d"),Ret);
		MessageBox(ErrStr);
		return;
	}
    
	TempStr.Format(_T("        %d        "),Handle[CyclicTxMsgCnt]);

	TempStr.Format(_T("%d"),Handle[CyclicTxMsgCnt]); //Set msglist element
	m_msglist.InsertItem(Handle[CyclicTxMsgCnt],TempStr);
	TempStr.Format(_T("%s"),Mode?_T("29-bit ID"):_T("11-bit ID"));
	m_msglist.SetItemText(Handle[CyclicTxMsgCnt],1,TempStr);
	TempStr.Format(_T("%lX"),MsgID);
	m_msglist.SetItemText(Handle[CyclicTxMsgCnt],2,TempStr);
	TempStr.Format(_T("%c"),RTR?'Y':'N');
	m_msglist.SetItemText(Handle[CyclicTxMsgCnt],3,TempStr);
	TempStr.Format(_T("%d"),DataLen);
	m_msglist.SetItemText(Handle[CyclicTxMsgCnt],4,TempStr);
	for (i=0;i<8;i++){
		if (i<DataLen && !m_rtr.GetCheck()) TempStr.Format(_T("%lX"),Data[i]);
		else TempStr=" ";
		m_msglist.SetItemText(Handle[CyclicTxMsgCnt],5+i,TempStr);
	}
	TempStr.Format(_T("%lu"),TimePeriod);
	m_msglist.SetItemText(Handle[CyclicTxMsgCnt],13,TempStr);
	TempStr.Format(_T("%lu"),Counter);
	m_msglist.SetItemText(Handle[CyclicTxMsgCnt],14,TempStr);
	m_msglist.SetItemText(Handle[CyclicTxMsgCnt],15,_T("Disable"));
	CyclicTxMsgCnt++;
}

void CSendCyclicMsgDlg::OnDeleteButton() 
{
	// TODO: Add your control notification handler code here
	wchar_t* endtemp,TempArr[20];
	BYTE SelectedHandle;
	int Ret,SelectedListNo;
	CString ErrStr;

	if (CyclicTxMsgCnt==0){
		MessageBox(_T("No cyclic tramsmission message can be deleted"));
		return;
	}
	
	SelectedListNo=m_msglist.GetNextItem(-1,LVIS_SELECTED); //Get selected list No
	if (SelectedListNo>CyclicTxMsgCnt || SelectedListNo<0) return;
	m_msglist.GetItemText(SelectedListNo,0,TempArr,20); //Get handle value
	SelectedHandle=(BYTE)(_tcstoul(TempArr,&endtemp,10)&0xff);
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_DeleteCyclicTxMsg(SelectedSlotNo,SelectedHandle); //Delete selected cyclic transmission message
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		ErrStr.Format(_T("Delete Cyclic Message Error, Error Code=%d"),Ret);
		MessageBox(ErrStr);
		return;
	}
	m_msglist.DeleteItem(SelectedListNo);
	CyclicTxMsgCnt--;
}

void CSendCyclicMsgDlg::OnEnableButton() 
{
	// TODO: Add your control notification handler code here
	wchar_t* endtemp,TempArr[20];
	BYTE SelectedHandle;
	int Ret,SelectedListNo;
	DWORD RestCnt;
	CString ErrStr;
	
	if (CyclicTxMsgCnt==0){
		MessageBox(_T("No cyclic tramsmission message can be enable"));
		return;
	}
	SelectedListNo=m_msglist.GetNextItem(-1,LVIS_SELECTED);  //Get selected list No
	if (SelectedListNo>CyclicTxMsgCnt || SelectedListNo<0) return;
	m_msglist.GetItemText(SelectedListNo,0,TempArr,20); //Get handle value
	SelectedHandle=(BYTE)(_tcstoul(TempArr,&endtemp,10)&0xff);
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_EnableCyclicTxMsg(SelectedSlotNo,SelectedHandle); //Enable selected cyclic transmission message.
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		ErrStr.Format(_T("Enable Cyclic Message Error, Error Code=%d"),Ret);
		MessageBox(ErrStr);
		return;
	}
	m_msglist.GetItemText(SelectedListNo,14,TempArr,20); //Get Tx times
	RestCnt=_tcstoul(TempArr,&endtemp,10);
	if (RestCnt){
		CString RestCntStr;
		RestCntStr.Format(_T("%d"),RestCnt);
		m_msglist.SetItemText(SelectedListNo,15,RestCntStr);
	}
	else{
		m_msglist.SetItemText(SelectedListNo,15,_T("Running"));
	}
}

void CSendCyclicMsgDlg::OnDisableButton() 
{
	// TODO: Add your control notification handler code here
	wchar_t* endtemp,TempArr[20];
	int Ret,SelectedListNo;
	BYTE SelectedHandle;
	CString ErrStr;
	
	if (CyclicTxMsgCnt==0){
		MessageBox(_T("No cyclic tramsmission message can be disable"));
		return;
	}
	SelectedListNo=m_msglist.GetNextItem(-1,LVIS_SELECTED); //Get selected list No
	if (SelectedListNo>=CyclicTxMsgCnt || SelectedListNo<0) return;
	m_msglist.GetItemText(SelectedListNo,0,TempArr,20); //Get handle value
	SelectedHandle=(BYTE)(_tcstoul(TempArr,&endtemp,10)&0xff);
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_DisableCyclicTxMsg(SelectedSlotNo,SelectedHandle); //Disable selected cyclic transmission message.
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		ErrStr.Format(_T("Disable Cyclic Message Error, Error Code=%d"),Ret);
		MessageBox(ErrStr);
		return;
	}
	m_msglist.SetItemText(SelectedListNo,15,_T("Disable"));
}

void CSendCyclicMsgDlg::OnRtrCheck() 
{
	// TODO: Add your control notification handler code here
	int i;
	CEdit *TempEdit[8]={&m_d0,&m_d1,&m_d2,&m_d3,&m_d4,&m_d5,&m_d6,&m_d7};

	if (m_rtr.GetCheck()){
		for (i=0;i<8;i++) TempEdit[i]->EnableWindow(false);
	}
	else{
		this->OnSelchangeDlenCombo();
	}	
}

BOOL CSendCyclicMsgDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	//recover the system resource
	EnterCriticalSection(&AccessI8120W_cs);
	I8120_RestoreI8120((BYTE)SelectedSlotNo);
	LeaveCriticalSection(&AccessI8120W_cs);
	return CDialog::DestroyWindow();
}

void CSendCyclicMsgDlg::OnCbnSelchangeSlotCombo()
{
	// TODO: Add your control notification handler code here
	if (SelectedSlotNo!=m_slot.GetCurSel()){
		EnterCriticalSection(&AccessI8120W_cs);
		I8120_RestoreI8120(SelectedSlotNo);
		LeaveCriticalSection(&AccessI8120W_cs);
		SelectedSlotNo=m_slot.GetCurSel();
		m_add.EnableWindow(FALSE);
		m_delete.EnableWindow(FALSE);
		m_enable.EnableWindow(FALSE);
		m_disable.EnableWindow(FALSE);
		KillTimer(12345);
	}
}

void CSendCyclicMsgDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	wchar_t* endtemp,TempArr[20];
	int Ret,i;
	BYTE SelectedHandle;
	DWORD RestCnt,SetTimes;
	CString RestCntStr;
	
	if (CyclicTxMsgCnt){
		for (i=0;i<CyclicTxMsgCnt;i++){
			m_msglist.GetItemText(i,0,TempArr,20); //Get handle value
			SelectedHandle=(BYTE)(_tcstoul(TempArr,&endtemp,10)&0xff);
			m_msglist.GetItemText(i,14,TempArr,20); //Get handle value
			SetTimes=_tcstoul(TempArr,&endtemp,10);
			if (SetTimes){
				m_msglist.GetItemText(i,15,TempArr,2);
				if (TempArr[0]!='D'){
					EnterCriticalSection(&AccessI8120W_cs);
					Ret=I8120_CheckCyclicTxRestMsg(SelectedSlotNo,SelectedHandle,&RestCnt); //Disable selected cyclic transmission message.
					LeaveCriticalSection(&AccessI8120W_cs);
					if (Ret==0){
						RestCntStr.Format(_T("%d"),RestCnt);
						m_msglist.SetItemText(i,15,RestCntStr);
					}
					if (RestCnt==0){
						m_msglist.SetItemText(i,15,_T("Disable"));
					}
				}
			}
		}
	}
	CDialog::OnTimer(nIDEvent);
}
