Imports I8120net_PAC

Public Class Form1
    Dim Slot As Byte
    Dim Baud As Byte

    Dim t_Rtr As Byte
    Dim t_Mode As Byte
    Dim t_Dlen As Byte
    Dim t_CyclicCnt As Byte
    Dim t_Handle(5) As Byte

    Private Sub Combo_Slot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Slot.SelectedIndexChanged
        If Slot <> Combo_Slot.SelectedIndex + 1 Then
            SyncLock Me
                'This is used to avoid mulit-accessing the same I-8120W
                'in the different functions or threads simultaneously. It is useless 
                'while the functions or threads access the I-8120W with different slot.
                I8120.I8120_RestoreI8120(Slot)
            End SyncLock
            Slot = Combo_Slot.SelectedIndex + 1
            Btn_Add.Enabled = False
            Btn_Del.Enabled = False
            Btn_Enable.Enabled = False
            Btn_Disable.Enabled = False
            Timer1.Enabled = False
        End If
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged
        Baud = Combo_Baud.SelectedIndex + 1
    End Sub

    Private Sub Combo_Len_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Len.SelectedIndexChanged
        t_Dlen = Combo_Len.SelectedIndex
    End Sub

    Private Sub Btn_Init_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Init.Click
        Dim Ret As Integer

        SyncLock Me
            Ret = I8120.I8120_Init(Slot)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 Init Err = " + Str(Ret))
            Exit Sub
        End If

        SyncLock Me
            Ret = I8120.I8120_HardwareReset(Slot)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 HardwareReset Err = " + Str(Ret))
            Exit Sub
        End If

        SyncLock Me
            Ret = I8120.I8120_ConfigWithoutStruct(Slot, 0, 4294967295, Baud, 0, 0)
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 HardwareReset Err = " + Str(Ret))
            Exit Sub
        End If
        Btn_Add.Enabled = True
        Btn_Del.Enabled = True
        Btn_Enable.Enabled = True
        Btn_Disable.Enabled = True
        Timer1.Enabled = True

    End Sub

    Private Sub ID_Bit11_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ID_Bit11.Click
        If (ID_Bit11.Checked = True) Then
            ID_Bit29.Checked = False
            t_Mode = 0
            Text_ID.MaxLength = 3
            Text_ID.Text = "7FF"
        End If
    End Sub

    Private Sub ID_Bit29_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ID_Bit29.Click
        If (ID_Bit29.Checked = True) Then
            ID_Bit11.Checked = False
            t_Mode = 1
            Text_ID.MaxLength = 8
            Text_ID.Text = "1FFFFFFF"
        End If
    End Sub

    Private Sub Check_RTR_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Check_RTR.Click
        If (Check_RTR.Checked = True) Then
            t_Rtr = 1
        Else
            t_Rtr = 0
        End If
    End Sub

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        SyncLock Me
            I8120.I8120_RestoreI8120(Slot)
        End SyncLock
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Btn_Add.Enabled = False
        Btn_Del.Enabled = False
        Btn_Enable.Enabled = False
        Btn_Disable.Enabled = False


        Combo_Slot.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 7
        Combo_Len.SelectedIndex = 0
        Slot = 1
        Baud = 8

        t_Rtr = 0
        t_Mode = 0
        t_Dlen = 0
        t_CyclicCnt = 0
    End Sub

    Private Sub Btn_Add_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Add.Click
        Dim Ret As Integer, i As Integer
        Dim t_ID As UInt32
        Dim Data(8) As Byte, ID_Len As Byte
        Dim TimePeriod As ULong
        Dim Counter As ULong
        Dim StrText As String, StrData As String, StrID As String

        StrID = ""
        ID_Len = Len(Text_ID.Text)
        If (t_Mode <> 0) Then
            For i = 1 To 8 - ID_Len
                StrID = "0" + StrID
            Next
        Else
            For i = 1 To 3 - ID_Len
                StrID = "0" + StrID
            Next
        End If
        StrID = Trim(StrID + Text_ID.Text)
        t_ID = Val("&H" + StrID + "&")
        Data(0) = Val("&H" + Text_D0.Text)
        Data(1) = Val("&H" + Text_D1.Text)
        Data(2) = Val("&H" + Text_D2.Text)
        Data(3) = Val("&H" + Text_D3.Text)
        Data(4) = Val("&H" + Text_D4.Text)
        Data(5) = Val("&H" + Text_D5.Text)
        Data(6) = Val("&H" + Text_D6.Text)
        Data(7) = Val("&H" + Text_D7.Text)
        TimePeriod = Val(Text_Peri.Text)
        Counter = Val(Text_Cnt.Text)

        SyncLock Me
            Ret = I8120.I8120_AddCyclicTxMsg(Slot, t_Mode, t_ID, t_Rtr, t_Dlen, Data, TimePeriod, Counter, t_Handle(t_CyclicCnt)) 'Add cyclic transmission message
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 Add Cyclic Messages Err = " + Str(Ret))
            Exit Sub
        End If

        StrData = ""
        If (t_Rtr <> 0) Then
            If (t_Mode <> 0) Then
                StrText = "[" + Trim(Str(t_Handle(t_CyclicCnt))) + "] " + "2.0B,ID=" + StrID + ",RTR=Y,L=" + Str(t_Dlen)
            Else
                StrText = "[" + Trim(Str(t_Handle(t_CyclicCnt))) + "] " + "2.0A,ID=" + StrID + ",RTR=Y,L=" + Str(t_Dlen)
            End If
        Else
            For i = 0 To t_Dlen - 1
                If (Data(i) > &HF) Then
                    StrData = StrData + Hex(Data(i)) + " "
                Else
                    StrData = StrData + "0" + Hex(Data(i)) + " "
                End If
            Next
            If (t_Dlen > 0) Then
                StrData = ",Data=" + StrData
            End If
            If (t_Mode <> 0) Then
                StrText = "[" + Trim(Str(t_Handle(t_CyclicCnt))) + "] " + "2.0B,ID=" + StrID + ",RTR=N,L=" + Str(t_Dlen)
            Else
                StrText = "[" + Trim(Str(t_Handle(t_CyclicCnt))) + "] " + "2.0A,ID=" + StrID + ",RTR=N,L=" + Str(t_Dlen)
            End If
        End If

        List_Msg.Items.Add(StrText + StrData + ",Period=" + Str(TimePeriod) + ",Times:" + Str(Counter) + ",Disable")

        t_CyclicCnt = t_CyclicCnt + 1
    End Sub

    Private Sub Btn_Del_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Del.Click
        Dim Ret As Integer
        Dim Temp_Handle As Byte, Temp_Cnt As Byte

        If (t_CyclicCnt = 0) Then
            MessageBox.Show("No cyclic tramsmission message can be delete")
            Exit Sub
        End If

        If (List_Msg.Text = "") Then Exit Sub

        Temp_Cnt = Val(List_Msg.Text.Substring(1, 1))
        If ((Temp_Cnt > 5) Or (Temp_Cnt < 0)) Then Exit Sub

        Temp_Handle = t_Handle(Temp_Cnt)
        SyncLock Me
            Ret = I8120.I8120_DeleteCyclicTxMsg(Slot, Temp_Handle)  'Delete selected cyclic transmission message
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 Delete Cyclic Message Err = " + Str(Ret))
            Exit Sub
        End If

        List_Msg.Items.Remove(List_Msg.SelectedItem)
        t_CyclicCnt = t_CyclicCnt - 1
    End Sub

    Private Sub Btn_Enable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Enable.Click
        Dim Ret As Integer, Item_Index As Integer, CntValue As Integer
        Dim Temp_Handle As Byte, Temp_Cnt As Byte
        Dim StrText As String

        If (t_CyclicCnt = 0) Then
            MessageBox.Show("No cyclic tramsmission message can be enable")
            Exit Sub
        End If

        If (List_Msg.Text = "") Then Exit Sub

        Temp_Cnt = Val(List_Msg.Text.Substring(1, 1))
        If ((Temp_Cnt > 5) Or (Temp_Cnt < 0)) Then Exit Sub

        Temp_Handle = t_Handle(Temp_Cnt)
        SyncLock Me
            Ret = I8120.I8120_EnableCyclicTxMsg(Slot, Temp_Handle)  'Enable selected cyclic transmission message.
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 Enable Cyclic Message Err = " + Str(Ret))
            Exit Sub
        End If

        StrText = List_Msg.Text
        StrText = StrText.Replace("Disable", "Enable")
        CntValue = Val(StrText.Substring(InStr(StrText, "Times:") + 6, InStr(StrText, ",Enable") - (InStr(StrText, "Times:") + 6)))
        If (CntValue > 0) Then
            StrText = StrText + ",Cnt:" + Str(CntValue)
        End If
        Item_Index = List_Msg.SelectedIndex
        List_Msg.Items.Item(Item_Index) = StrText
    End Sub

    Private Sub Btn_Disable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Disable.Click
        Dim Ret As Integer, Item_Index As Integer
        Dim Temp_Handle As Byte, Temp_Cnt As Byte
        Dim StrText As String

        If (t_CyclicCnt = 0) Then
            MessageBox.Show("No cyclic tramsmission message can be disable")
            Exit Sub
        End If

        If (List_Msg.Text = "") Then Exit Sub

        Temp_Cnt = Val(List_Msg.Text.Substring(1, 1))
        If ((Temp_Cnt > 5) Or (Temp_Cnt < 0)) Then Exit Sub

        Temp_Handle = t_Handle(Temp_Cnt)
        SyncLock Me
            Ret = I8120.I8120_DisableCyclicTxMsg(Slot, Temp_Handle)  'Disable selected cyclic transmission message.
        End SyncLock
        If (Ret <> 0) Then
            MessageBox.Show("I-8120 Disable Cyclic Message Err = " + Str(Ret))
            Exit Sub
        End If

        StrText = List_Msg.Text
        StrText = StrText.Replace("Enable", "Disable")
        Item_Index = List_Msg.SelectedIndex
        List_Msg.Items.Item(Item_Index) = StrText
    End Sub

    Private Sub Text_ID_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Text_ID.TextChanged
        If t_Mode <> 0 Then
            If Val(Text_ID.Text) > &H1FFFFFFF Then Text_ID.Text = "1FFFFFFF"
        Else
            If Val(Text_ID.Text) > &H7FF Then Text_ID.Text = "7FF"
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim RestCnt As UInt32
        Dim Ret As Integer, i As Integer, SubStrLen1 As Integer, SubStrLen2 As Integer, SendCnt As Integer
        Dim SelectedHandle As Byte
        Dim TempStr As String

        If (t_CyclicCnt <> 0) Then
            For i = 0 To (t_CyclicCnt - 1)
                TempStr = List_Msg.Items.Item(i).ToString()
                SelectedHandle = Val(TempStr.Substring(1, 1))
                If (SelectedHandle < 5) And (SelectedHandle >= 0) Then
                    SubStrLen2 = InStr(TempStr, ",Enable")
                    If (SubStrLen2 > 0) Then
                        SubStrLen1 = InStr(TempStr, "Times:")
                        SendCnt = Val(TempStr.Substring(SubStrLen1 + 6, SubStrLen2 - (SubStrLen1 + 6)))
                        If (SendCnt > 0) Then
                            SyncLock Me
                                Ret = I8120.I8120_CheckCyclicTxRestMsg(Slot, SelectedHandle, RestCnt) 'Disable selected cyclic transmission message.
                            End SyncLock
                            If (Ret = 0) Then
                                If (RestCnt = 0) Then
                                    TempStr = TempStr.Replace("Enable", "Disable")
                                    TempStr = TempStr.Substring(0, InStr(TempStr, ",Cnt:") - 1)
                                    List_Msg.Items.Item(i) = TempStr
                                Else
                                    TempStr = TempStr.Substring(0, InStr(TempStr, ",Cnt:") + 5) + Str(RestCnt)
                                    List_Msg.Items.Item(i) = TempStr
                                End If
                            End If
                        End If
                    End If
                End If
            Next
        End If

    End Sub
End Class
