// SendMsgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SendMsg.h"
#include "SendMsgDlg.h"
#include "I8120.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSendMsgDlg dialog
CRITICAL_SECTION  AccessI8120W_cs; //The critical section is used to avoid mulit-accessing the same I-8120W
                                   //in the different functions or threads simultaneously. It is useless 
                                   //while the functions or threads access the I-8120W with different slot.
CSendMsgDlg::CSendMsgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSendMsgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSendMsgDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSendMsgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSendMsgDlg)
	DDX_Control(pDX, IDC_DATALEN_EDIT, m_DataLen);
	DDX_Control(pDX, IDC_11BIT_RADIO, m_11bit);
	DDX_Control(pDX, IDC_29BIT_RADIO, m_29bit);
	DDX_Control(pDX, IDC_SLOT_COMBO, m_Slot);
	DDX_Control(pDX, IDC_SEND_BUTTON, m_Send);
	DDX_Control(pDX, IDC_RTR_CHECK, m_RTR);
	DDX_Control(pDX, IDC_INIT_BUTTON, m_Init);
	DDX_Control(pDX, IDC_ID_EDIT, m_ID);
	DDX_Control(pDX, IDC_DATA_EDIT, m_Data);
	DDX_Control(pDX, IDC_BAUD_COMBO, m_Baud);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSendMsgDlg, CDialog)
	//{{AFX_MSG_MAP(CSendMsgDlg)
	ON_CBN_SELENDOK(IDC_SLOT_COMBO, OnSelendokSlotCombo)
	ON_BN_CLICKED(IDC_INIT_BUTTON, OnInitButton)
	ON_BN_CLICKED(IDC_SEND_BUTTON, OnSendButton)
	ON_BN_CLICKED(IDC_29BIT_RADIO, On29bitRadio)
	ON_BN_CLICKED(IDC_11BIT_RADIO, On11bitRadio)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendMsgDlg message handlers
WORD OldSlotSelect=1;

void CSendMsgDlg::FormInit(void){
	//Initiate all objects and parameters used in the dialog
	m_11bit.EnableWindow(FALSE);
	m_29bit.EnableWindow(FALSE);
	m_ID.EnableWindow(FALSE);
	m_RTR.EnableWindow(FALSE);
	m_DataLen.EnableWindow(FALSE);
	m_Data.EnableWindow(FALSE);
	m_Send.EnableWindow(FALSE);
}

BOOL CSendMsgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	//initial button
	FormInit();

	//parameter initialize
	m_Slot.InsertString(0,_T(" Slot 1"));
	m_Slot.InsertString(1,_T(" Slot 2"));
	m_Slot.InsertString(2,_T(" Slot 3"));
	m_Slot.InsertString(3,_T(" Slot 4"));
	m_Slot.InsertString(4,_T(" Slot 5"));
	m_Slot.InsertString(5,_T(" Slot 6"));
	m_Slot.InsertString(6,_T(" Slot 7"));
	m_Slot.SetCurSel(0);
	m_Baud.InsertString(0,_T("   10K bps  "));
	m_Baud.InsertString(1,_T("   20K bps  "));
	m_Baud.InsertString(2,_T("   50K bps  "));
	m_Baud.InsertString(3,_T("  125K bps  "));
	m_Baud.InsertString(4,_T("  250K bps  "));
	m_Baud.InsertString(5,_T("  500K bps  "));
	m_Baud.InsertString(6,_T("  800K bps  "));
	m_Baud.InsertString(7,_T(" 1000K bps  "));
	m_Baud.SetCurSel(7);
	OldSlotSelect=0;
	m_11bit.SetCheck(BST_CHECKED);
	m_Baud.SetCurSel(11);
	m_DataLen.LimitText(1);
	m_DataLen.SetWindowText(_T("8"));
	m_Data.LimitText(23);
	m_Data.SetWindowText(_T("FF FF FF FF FF FF FF FF"));
	m_ID.LimitText(3);
	m_ID.SetWindowText(_T("3FF"));
	m_11bit.SetCheck(TRUE);

	InitializeCriticalSection(&AccessI8120W_cs);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSendMsgDlg::OnSelendokSlotCombo() 
{
	//Check if the slot combo box is changed or not, and do something for different situation
	if ((m_Slot.GetCurSel()+1)!=OldSlotSelect){
		EnterCriticalSection(&AccessI8120W_cs);
		I8120_RestoreI8120((BYTE)OldSlotSelect);
		LeaveCriticalSection(&AccessI8120W_cs);
		KillTimer(12345);
		FormInit();
		OldSlotSelect=m_Slot.GetCurSel()+1;
		return;
	}
}

void CSendMsgDlg::OnInitButton() 
{
	wchar_t wTempStr[100];
	WORD Ret;
	CString TempStr;

	OldSlotSelect=m_Slot.GetCurSel()+1;
	//configue the I-8120W setting and initiate the I-8120W
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_Init((BYTE)OldSlotSelect);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		wsprintf(wTempStr,_T("Initiate I-8120W Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_HardwareReset((BYTE)OldSlotSelect);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		wsprintf(wTempStr,_T("Reset I-8120W Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_ConfigWithoutStruct((BYTE)OldSlotSelect,0UL,0xffffffffUL,(m_Baud.GetCurSel()+1),0,0);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		wsprintf(wTempStr,_T("Configure I-8120W Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	//start the objects and parameters used in the dialog
	m_11bit.EnableWindow(TRUE);
	m_29bit.EnableWindow(TRUE);
	m_ID.EnableWindow(TRUE);
	m_RTR.EnableWindow(TRUE);
	m_DataLen.EnableWindow(TRUE);
	m_Data.EnableWindow(TRUE);
	m_Send.EnableWindow(TRUE);
	SetTimer(12345,10,NULL);
}

void CSendMsgDlg::OnSendButton() 
{
	wchar_t wTempStr[100],*wendptr;
	char TempStr[100],*ptr1,*ptr2,*endptr;
	BYTE Mode,RTR,DataLen,Data[8];
	WORD i,Ret;
	DWORD ID;

	//configue the transmit CAN message
	m_ID.GetWindowText(wTempStr,16);
	ID=_tcstoul(wTempStr,&wendptr,16);
	if (m_11bit.GetCheck()){
		Mode=0;
	}
	else{
		Mode=1;
	}
	if (m_RTR.GetCheck()){
		RTR=1;
	}
	else{
		RTR=0;
	}
	m_DataLen.GetWindowText(wTempStr,2);
	DataLen=(BYTE)(_tcstoul(wTempStr,&wendptr,10)&0xff);
	if (DataLen>8) DataLen=8;
	m_Data.GetWindowText(wTempStr,46);
	wcstombs(TempStr,wTempStr,46);
	sprintf(TempStr,"%s ",TempStr);
	i=0;
	ptr1=TempStr;
	ptr2=strchr(TempStr,' ');
	while(ptr2){
		*ptr2=0;
		if (i>7) break;
		Data[i]=(BYTE)(strtoul(ptr1, &endptr,16)&0xff);
		i++;
		ptr1=ptr2+1;
		ptr2=strchr(ptr1,' ');
	}
	while(i<DataLen){
		Data[i]=0;
		i++;
	}

	//Send the CAN message out
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_SendWithoutStruct((BYTE)OldSlotSelect,Mode,ID,RTR,DataLen,Data);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		wsprintf(wTempStr,_T("Send CAN Message Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
	}

}

void CSendMsgDlg::On29bitRadio() 
{
	// TODO: Add your control notification handler code here
	m_ID.LimitText(8);
	m_ID.SetWindowText(_T("1FFFFFFF"));	
}

void CSendMsgDlg::On11bitRadio() 
{
	// TODO: Add your control notification handler code here
	m_ID.LimitText(3);
	m_ID.SetWindowText(_T("3FF"));
}

void CSendMsgDlg::OnTimer(UINT nIDEvent) 
{
	BYTE TxStatus;
	int Ret;
	wchar_t wTempStr[100];
	static unsigned int MessageBoxFlag;
	// TODO: Add your message handler code here and/or call default
	//Chcek if I-8120W has finished the transmission of CAN messages in the buffer of I-8120W
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_IsTxTimeout((BYTE)OldSlotSelect,&TxStatus);
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		wsprintf(wTempStr,_T("I8120_IsTxTimeout Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		KillTimer(12345);
	}
	if (TxStatus){
		if (!MessageBoxFlag){
			MessageBoxFlag=1;
			MessageBox(_T("Send CAN Message Error"));
		}
	}
	else{
		MessageBoxFlag=0;
	}
	CDialog::OnTimer(nIDEvent);
}

BOOL CSendMsgDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class

	//recover the system resource
	EnterCriticalSection(&AccessI8120W_cs);
	I8120_RestoreI8120((BYTE)OldSlotSelect);
	LeaveCriticalSection(&AccessI8120W_cs);
	KillTimer(12345);
	return CDialog::DestroyWindow();
}
